Index: trunk/kernel/kern/core.c
===================================================================
--- trunk/kernel/kern/core.c	(revision 690)
+++ trunk/kernel/kern/core.c	(revision 1)
@@ -1,7 +1,8 @@
 /*
  * core.c - core descriptor access function.
- *
+ * 
  * Author  Ghassan Almaless (2008,2009,2010,2011,2012)
- *         Alain Greiner    (2016,2017,2018,2019,2020)
+ *         Mohamed Lamine Karaoui (2015)
+ *         Alain Greiner (2016)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -23,21 +24,23 @@
  */
 
-#include <kernel_config.h>
-#include <hal_kernel_types.h>
+#include <almos_config.h>
+#include <hal_types.h>
 #include <hal_special.h>
+#include <errno.h>
 #include <printk.h>
 #include <thread.h>
-#include <chdev.h>
-#include <alarm.h>
-#include <dev_pic.h>
+#include <dev_icu.h>
 #include <rpc.h>
 #include <cluster.h>
 #include <kmem.h>
+#include <sysfs.h>
+#include <dqdt.h>
 #include <core.h>
 
+
 /////////////////////////////////
-void core_init( core_t    * core,
-                lid_t       lid,
-                gid_t       gid )
+void core_init( core_t    * core, 
+                uint32_t    lid, 
+                uint32_t    gid )
 {
 	core->lid               = lid;
@@ -46,82 +49,21 @@
 	core->time_stamp        = 0;
 	core->ticks_nr          = 0;
+	core->ticks_period      = CONFIG_SCHED_TICK_PERIOD;
 	core->usage             = 0;
-	core->fpu_owner         = NULL;
-	core->rand_last         = hal_time_stamp() & 0xFFF;
-
-    // initialize the scheduler
+	core->spurious_irqs     = 0;
+    core->rpc_threads       = 0;
+
+	rpc_fifo_init( &core->rpc_fifo );
+
+    list_root_init( &core->rpc_free_list );
+
+    core->thread_rpc        = NULL;
+    core->thread_idle       = NULL;
+    core->fpu_owner         = NULL;
+	core->rand_last         =  hal_time_stamp() & 0xFFF;
+
 	sched_init( core );
 
-    // initialise the alarms lock
-    remote_busylock_init( XPTR( local_cxy , &core->alarms_lock ) , LOCK_CORE_ALARMS );
-
-    // initialise the alarms list 
-    list_root_init( &core->alarms_root );
-}
-
-////////////////////////////////////////////////////////////////////////////////////
-// This static function checks the alarms registered in the core, and calls the
-// relevant alarm handler for all alarms whose time is elapded.
-// It does not take the lock protecting the alarm list, because it access only
-// the first alarm in the list, and all modifications in he list are done
-// the low level access functions called by the handler(s). 
-////////////////////////////////////////////////////////////////////////////////////
-static void core_check_alarms( core_t * core )
-{
-    alarm_handler_t * handler;
-
-    // get pointer on root of alarms list
-    list_entry_t * root = &core->alarms_root;
-
-    // does nothing if list is empty
-    if( list_is_empty( root ) ) return;
-
-    while( 1 )
-    {
-        // get pointer on first alarm
-        alarm_t * alarm = LIST_FIRST( root , alarm_t , list );
-
-        // get first alarm date
-        cycle_t alarm_date = alarm->date; 
-
-        // get current date
-        cycle_t current_date = hal_get_cycles();
-
-        // call handler if delay elapsed, and retry
-        if( current_date >= alarm_date )
-        {
-            // get pointer on registered alarm handler
-            handler = (alarm_handler_t *)alarm->func_ptr;
-
-            // call alarm handler
-            handler( alarm->args_xp );
-        }
-        else   // exit loop when first alarm delay not elapsed
-        {
-            break;
-        }
-    }
-}   // end core_check_alarms()
-
-//////////////////////
-lid_t core_lid( void )
-{
-    uint32_t    i;
-
-    // get pointer on local cluser descriptor
-    cluster_t * cluster = LOCAL_CLUSTER;
-
-    // get core gid from hardware register
-    gid_t gid = hal_get_gid();
-
-    // makes an associative search in core_tbl[] from gid
-    for( i = 0 ; i < cluster->cores_nr ; i++ )
-    {
-        if( gid == cluster->core_tbl[i].gid ) return i;
-    }
-
-    assert( __FUNCTION__, false , "core not found" );
-
-    return 0;
+	core->icu               = NULL;          // TODO ??? [AG]
 }
 
@@ -129,23 +71,67 @@
 inline uint32_t core_get_rand( core_t * core )
 {
-	uint32_t value  = ((core->rand_last * CONFIG_RDNG_PARAM_A) +
-	                    CONFIG_RDNG_PARAM_C) ^ (hal_get_cycles() & 0xFFF);
-	core->rand_last = value;
-	return value;
+    uint32_t value  = ((core->rand_last * CONFIG_RDNG_PARAM_A) +
+                        CONFIG_RDNG_PARAM_C) ^ (hal_time_stamp() & 0xFFF);
+    core->rand_last = value;
+    return value;
+}
+
+////////////////////////////////////////////////
+inline uint64_t core_get_cycles( core_t * core )
+{
+    uint32_t elapsed;
+    uint64_t cycles;
+	uint32_t time_stamp = core->time_stamp;
+	uint32_t time_now   = hal_time_stamp();
+	
+	// compute number of elapsed cycles, taking into account 32 bits register wrap
+	if(time_now < time_stamp) elapsed = (0xFFFFFFFF - time_stamp) + time_now;
+	else                      elapsed = (time_now - time_stamp);
+
+    cycles = core->cycles + elapsed;
+
+    // update core time
+    core->time_stamp = time_now;
+    core->cycles     = cycles;
+	hal_wbflush();
+
+	return cycles;
 }
 
 ////////////////////////////////////
 void core_get_time( core_t   * core,
-                    uint32_t * tm_s, 
+                    uint32_t * tm_ms, 
                     uint32_t * tm_us )
 {
-    // get number of cycles
-    uint64_t cycles = core->cycles;
-
-    // get number of cycles per second
-    uint32_t cycles_per_second = LOCAL_CLUSTER->sys_clk;
-
-    *tm_s  = cycles / cycles_per_second;
-    *tm_us = (cycles * 1000000) % cycles_per_second;
+	// uint64_t cycles = core_get_cycles( core );
+
+    // TODO ces deux ligne ne compilent pas : "undefined referenc to __udivdi3"
+
+	// *tm_ms = (cycles / CONFIG_CYCLES_PER_MS);
+	// *tm_us = (cycles % CONFIG_CYCLES_PER_MS) / (CONFIG_CYCLES_PER_MS / 1000000);
+
+    printk("\n[PANIC] in %s : not implemented yet\n", __FUNCTION__ );
+}
+
+//////////////////////////////////////
+void core_time_update( core_t * core )
+{
+    uint32_t elapsed;
+	uint32_t ticks_nr   = core->ticks_nr;
+	uint64_t cycles     = core->cycles;
+	uint32_t time_stamp = core->time_stamp;
+	uint32_t time_now   = hal_time_stamp();
+
+    // compute number of elapsed cycles taking into account 32 bits register wrap 
+	if( time_now < time_stamp ) elapsed = (0xFFFFFFFF - time_stamp) + time_now;
+	else                        elapsed = time_now - time_stamp;
+    
+	cycles  += elapsed;
+	ticks_nr = elapsed / core->ticks_period;
+
+	core->time_stamp     = time_now;
+	core->cycles         = cycles + elapsed;
+	core->ticks_nr       = ticks_nr + (elapsed / core->ticks_period);
+	hal_wbflush();
 }
 
@@ -155,18 +141,25 @@
 	uint32_t ticks;
 
-	// update ticks counter
-	ticks = core->ticks_nr++;
-
-    // handle alarms
-    core_check_alarms( core );
-
- 	// handle scheduler
-	if( (ticks % CONFIG_SCHED_TICKS_PER_QUANTUM) == 0 ) sched_yield( "TICK");
+    // update cycles and ticks counter
+	core_time_update( core );
+
+    // get current ticks number
+	ticks = core->ticks_nr;
+
+    // handle pending alarms TODO ??? [AG]
+	// alarm_clock( &core->alarm_mgr , ticks );
+
+    // handle scheduler TODO  improve the scheduling condition ... AG
+    if( (ticks % 10) == 0 ) sched_yield();
+	
+    // update DQDT TODO  This update should depend on the cluster identifier,
+    // to avoid simultaneous updates from various clusters ... AG
+	if( ((ticks % CONFIG_DQDT_PERIOD) == 0) && (core->lid == 0) ) dqdt_global_update();
 }
 
 ////////////////////////////////////////
-void core_compute_stats( core_t * core )
-{
-	thread_t * idle  = core->scheduler.idle;
+void core_compute_stats( core_t * core ) 
+{
+	thread_t * idle  = core->thread_idle;
 	uint32_t   ticks = core->ticks_nr;
 
@@ -175,5 +168,5 @@
 	uint32_t   usage;
 
-	// compute cumulated usage
+    // compute cumulated usage       
 	ticks         = (ticks) ? ticks : 1;
 	idle_percent  = (idle->ticks_nr * 100) / ticks;
@@ -182,7 +175,12 @@
 	usage         = (busy_percent + core->usage) / 2;
 
-	// update core descriptor
+    // update core descriptor
 	core->usage = usage;
-	hal_fence();
+	hal_wbflush();
+
+#if CONFIG_SHOW_CPU_USAGE
+	printk(INFO, "INFO: core %d in cluster %x : busy_percent = %d / cumulated_usage = %d\n",
+	       core->lid, local_cxy , busy_percent , usage );
+#endif
 
 	core->ticks_nr = 0;
@@ -193,11 +191,29 @@
 void core_reset_stats( core_t * core )
 {
-	thread_t * idle  = core->scheduler.idle;
-
-	core->ticks_nr = 0;
-	core->usage    = 0;
-	idle->ticks_nr = 0;
-
-	hal_fence();
-}
-
+	core_time_update(core);
+
+	core->ticks_nr              = 0;
+	core->usage                 = 0;
+	core->thread_idle->ticks_nr = 0;
+	hal_wbflush();
+}
+
+///////////////////////////////////////////////////
+void core_set_irq_vector_entry( xptr_t     core_xp,
+                                uint32_t   irq_type,
+                                uint32_t   irq_id,
+                                xptr_t     dev_xp )
+{
+    // get core cluster and local pointer
+    cxy_t    core_cxy = GET_CXY( core_xp );
+    core_t * core_ptr = (core_t *)GET_PTR( core_xp );
+
+    // compute xptr on relevant interrupt vector entry
+    xptr_t   xp;
+    if     ( irq_type == WTI_TYPE ) xp = XPTR( core_cxy , &core_ptr->wti_vector[irq_id] );
+    else if( irq_type == HWI_TYPE ) xp = XPTR( core_cxy , &core_ptr->hwi_vector[irq_id] );
+    else                            xp = XPTR( core_cxy , &core_ptr->pti_vector[irq_id] );
+
+    // set relevant IRQ vector entry
+    hal_remote_swd( xp , dev_xp );
+}
Index: trunk/kernel/kern/core.h
===================================================================
--- trunk/kernel/kern/core.h	(revision 690)
+++ trunk/kernel/kern/core.h	(revision 1)
@@ -1,7 +1,8 @@
 /*
  * core.h - core descriptor and associated access functions définition
- *
+ * 
  * Authors  Ghassan Almaless (2008,2009,2010,2011,2012)
- *          Alain Greiner (2016,2017,2018)
+ *          Mohamed Lamine Karaoui (2015)
+ *          Alain Greiner (2016)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -26,27 +27,19 @@
 #define _CORE_H_
 
-#include <kernel_config.h>
-#include <hal_kernel_types.h>
-#include <busylock.h>
+#include <almos_config.h>
+#include <hal_types.h>
 #include <list.h>
 #include <rpc.h>
 #include <scheduler.h>
+#include <sysfs.h>
 
 /****  Forward declarations  ****/
 
 struct thread_s;
-struct chdev_s;
+struct device_s;
+
 
 /****************************************************************************************
- * This structure defines a core descriptor.
- * Besides the core identifiers (gid,lid), it contains an embedded private scheduler
- * and a software cycles counter on 64 bits.
- * It contains also the root of local list of alarms, dynamically registered by the
- * threads running on this core. This local list is protected by a remote_busylock,
- * because it can be accessed by any thread, running in any cluster, and using the
- * access functions defined in the <alarm.c> & <alarm.h> files. 
- * It contains an architecture specific extension to store the interrupt vector(s).
- * The core_init()function must allocate memory for this extension, depending on the
- * PIC device implementation type.
+ * This structure defines the core descriptor
  ***************************************************************************************/
 
@@ -54,46 +47,49 @@
 {
 	lid_t               lid;            /*! core local index in cluster                */
-	gid_t               gid;            /*! core global identifier (hardware index)    */
-
-	scheduler_t         scheduler;      /*! embedded private scheduler                 */
-
+	gid_t               gid;            /*! core global identifier (hardware index)    */   
 	uint64_t            cycles;         /*! total number of cycles (from hard reset)   */
 	uint32_t            time_stamp;     /*! previous time stamp (read from register)   */
+	uint32_t            ticks_nr;       /*! number of elapsed ticks                    */
+	uint32_t            ticks_period;   /*! number of cycles between two ticks         */
+	uint32_t            usage;          /*! cumulated busy_percent (idle / total)      */
+	uint32_t            spurious_irqs;  /*! for instrumentation...                     */
+	struct thread_s   * thread_rpc;     /*! pointer on current RPC thread descriptor   */
+	struct thread_s   * thread_idle;    /*! pointer on idle thread descriptor          */
+	struct thread_s   * fpu_owner;      /*! pointer on current FPU owner thread        */ 
+    uint32_t            rand_last;      /*! last computed random value                 */
+	uint32_t            rpc_threads;    /*! total number of RPC threads for this core  */
+	list_entry_t        rpc_free_list;  /*! root of the list of free RPC threads       */
+	rpc_fifo_t          rpc_fifo;       /*! embedded private RPC fifo (one per core)   */
+	scheduler_t         scheduler;      /*! embedded private scheduler                 */
+    struct device_s   * icu;            /*! pointer on local ICU device descriptor     */
 
-    list_entry_t        alarms_root;    /*! root of list of attached alarms            */
-    remote_busylock_t   alarms_lock;    /*! lock protecting the list of alarms         */
+    xptr_t              hwi_vector[CONFIG_MAX_HWIS_PER_ICU];     /*! on source device  */
+    xptr_t              pti_vector[CONFIG_MAX_PTIS_PER_ICU];     /*! on source device  */
+    xptr_t              wti_vector[CONFIG_MAX_WTIS_PER_ICU];     /*! on source device  */
 
-	uint32_t            ticks_nr;       /*! number of elapsed ticks                    */
-	uint32_t            usage;          /*! cumulated busy_percent (idle / total)      */
-	struct thread_s   * fpu_owner;      /*! pointer on current FPU owner thread        */
-    uint32_t            rand_last;      /*! last computed random value                 */
-
-    void              * pic_extend;     /*! PIC implementation specific extension      */
-}
+	char                name[CONFIG_SYSFS_NAME_LEN];
+	sysfs_entry_t       node;
+} 
 core_t;
 
 /***************************************************************************************
- * This function initializes a core descriptor.
+ * This macro returns a pointer on the calling core descriptor.
+ **************************************************************************************/
+
+#define CURRENT_CORE  (CURRENT_THREAD->core)
+
+/***************************************************************************************
+ * TODO this initialisation must be completed for the thread_idle field... [AG]
+ * This function initializes a core descriptor from information found in arch_info.
  * It makes the association [gid] <=> [lid], as defined in arch_info, via the
  * boot_info_t structure build by the bootloader in each cluster.
- * It initializes the core scheduler structures, and the alarms list and lock.
- * It allocates memory for the PIC infrastructure specific core extension,
- * but it does NOT initialize the <pic_extend> fields, that must be completed later.
  ***************************************************************************************
  * @ core      : pointer on core descriptor to initialise.
- * @ lid       : local core index in cluster.
- * @ gid       : global core identifier (hardware index).
+ * @ lid       : local core index 
+ * @ gid       : global core identifier (hardware index)
  **************************************************************************************/
-void core_init( core_t          * core,
-                lid_t             lid,
-                gid_t             gid );
-
-/***************************************************************************************
- * This function returns the calling core local index (lid), making an associative
- * search in the local core_tbl[] array, based on the hardwired (gid).
- ***************************************************************************************
- * @ returns always the lid value.
- **************************************************************************************/
-lid_t core_lid( void );
+void core_init( core_t   * core, 
+                lid_t      lid, 
+                gid_t      gid );
 
 /***************************************************************************************
@@ -107,6 +103,19 @@
 
 /***************************************************************************************
- * This function returns the current date (seconds & micro-seconds) from 
- * the 64 bits calling core cycles counter.
+ * This function returns the current date (cycles) from both 
+ * the hardware 32 bits cycles counter and the core descriptor cycles counter, 
+ * taking into account the 32 bits hardware register overflow.
+ * The core descriptor time is updated.
+ ***************************************************************************************
+ * @ core       : pointer on core descriptor.
+ * @ returns the number of cycles.
+ **************************************************************************************/
+inline uint64_t core_get_cycles( core_t * core );
+
+/***************************************************************************************
+ * This function returns the current date (seconds & micro-seconds) from both
+ * the hardware 32 bits cycles counter and the core descriptor cycles counter, 
+ * taking into account the 32 bits hardware register overflow.
+ * The core descriptor time is updated.
  ***************************************************************************************
  * @ core      : pointer on core descriptor.
@@ -120,7 +129,8 @@
 /***************************************************************************************
  * This function must be called at each TICK.
- * - it updates the ticks counter in the calling core descriptor.
- * - it checks the registered alarms depending on the ticks counter value.
- * - it calls the scheduler, depending on the ticks counter value.
+ * It updates the  cycles and ticks counter in the calling core descriptor.
+ * It handles all pending alarms depending on the ticks counter value.
+ * It handles the scheduling, depending on the ticks counter value. 
+ * It handles the global DQDT update, depending on the ticks counter vakue.
  ***************************************************************************************
  * @ core       : pointer on core descriptor.
@@ -129,5 +139,5 @@
 
 /***************************************************************************************
- * This function updates the usage statistics for the calling core descriptor,
+ * This function updates the usage statistics for the calling core descriptor, 
  * based on the ratio between the idle_ticks and total_ticks.
  ***************************************************************************************
@@ -137,5 +147,5 @@
 
 /***************************************************************************************
- * This function reset the usage statistics.
+ * This function and reset the usage statistics.
  ***************************************************************************************
  * @ core       : pointer on core descriptor.
@@ -146,16 +156,16 @@
  * This function set/reset a selected entry in one interrupt vector for a remote core.
  * The written value is an extended pointer on the "source" device (or the XPTR_NULL
- * value in case of reset). As it uses remote access, this function can be called by
+ * value in case of reset). As it uses remote access, this function can be called by 
  * any thread in any cluster.
  ***************************************************************************************
- * @ core       : local pointer on the core descriptor.
+ * @ core_xp    : extended pointer on the core descriptor.
  * @ irq_type   : type of IRQ (HWI/WTI/PTI).
  * @ irq_id     : index in the IRQ vector.
- * @ chdev      : local pointer on the "source" chdev descriptor.
+ * @ dev_xp     : extended pointer on the "source" descriptor.
  **************************************************************************************/
-void core_set_irq_vector_entry( core_t          * core,
-                                uint32_t          irq_type,
-                                uint32_t          irq_id,
-                                struct chdev_s  * chdev );
+void core_set_irq_vector_entry( xptr_t     core_xp,
+                                uint32_t   irq_type,
+                                uint32_t   irq_id,
+                                xptr_t     dev_xp );
 
 
Index: trunk/kernel/kern/cpu-trace.h
===================================================================
--- trunk/kernel/kern/cpu-trace.h	(revision 1)
+++ trunk/kernel/kern/cpu-trace.h	(revision 1)
@@ -0,0 +1,108 @@
+/*
+ * kern/cpu-trace.h - Per-CPU, In-core trace system
+ * 
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _CPU_TRACE_H_
+#define _CPU_TRACE_H_
+
+#include <config.h>
+#include <types.h>
+#include <kdmsg.h>
+
+/** Opaque CPU trace recorder */
+struct cpu_trace_recorder_s;
+
+/** Write CPU trace information to current CPU recorder */
+#define cpu_trace_write(_cpu,func)
+
+/** Dump CPU trace log to specified tty */
+static inline void cpu_trace_dump(struct cpu_s *cpu);
+
+
+///////////////////////////////////////////////////////////////////////
+//                         Private Section                           //
+///////////////////////////////////////////////////////////////////////
+
+#define CPU_TRACE_LOG_LENGTH      100
+
+/** Private trace info structure */
+typedef struct cpu_trace_info_s
+{
+	uint_t time_stamp;
+	void *func_addr;
+	uint_t stack_ptr;
+	void *thread_ptr;
+	uint_t line;
+}cpu_trace_info_t;
+
+/** Opaque CPU trace recorder */
+struct cpu_trace_recorder_s
+{
+	uint_t current_index;
+	cpu_trace_info_t log[CPU_TRACE_LOG_LENGTH];
+};
+
+
+#if CONFIG_CPU_TRACE
+#undef  cpu_trace_write
+#define cpu_trace_write(_cpu,func)					\
+	do{{								\
+			uint_t state;					\
+			cpu_disable_all_irq(&state);			\
+			cpu_trace_info_t *info = &(_cpu)->trace_recorder->log[(_cpu)->trace_recorder->current_index]; \
+			info->time_stamp = cpu_time_stamp();		\
+			info->func_addr  = (func);			\
+			info->stack_ptr  = cpu_get_stack();		\
+			info->thread_ptr = cpu_get_current_thread();	\
+			(_cpu)->trace_recorder->current_index = ((_cpu)->trace_recorder->current_index  + 1) % CPU_TRACE_LOG_LENGTH; \
+			cpu_restore_irq(state);				\
+		}}while(0)
+
+static inline void cpu_trace_dump(struct cpu_s *cpu)
+{
+	register uint_t i;
+	register cpu_trace_info_t *info;
+  
+	except_dmsg("------------------------------------------\n");
+	except_dmsg("TRACE DUMP FOR CPU %d\n", cpu->gid);
+
+	for(i=0; i < CPU_TRACE_LOG_LENGTH; i++)
+	{
+		info = &cpu->trace_recorder->log[i];
+		except_dmsg("Entry %d\n", i);
+		except_dmsg("\tTimeStamp %d\n\tFunction: %x\n\tLine %d\n\tStack %x\n\tThread %x\n",
+			    info->time_stamp, info->func_addr, info->line, info->stack_ptr, info->thread_ptr);
+	}
+	except_dmsg("---> Current_index: %d\n", cpu->trace_recorder->current_index);
+}
+
+#else
+
+#define cpu_trace_write(_cpu,func)
+
+static inline void cpu_trace_dump(struct cpu_s *cpu)
+{
+	/* Nothing to do */
+}
+
+#endif	/* CONFIG_CPU_TRACE */
+
+#endif	/* _CPU_TRACE_H_ */
Index: trunk/kernel/kern/device.c
===================================================================
--- trunk/kernel/kern/device.c	(revision 1)
+++ trunk/kernel/kern/device.c	(revision 1)
@@ -0,0 +1,162 @@
+/*
+ * device.c - device descriptor operations implementation
+ *
+ * Authors  Alain Greiner   (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH.is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH.is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH.; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <almos_config.h>
+#include <hal_types.h>
+#include <hal_special.h>
+#include <boot_info.h>
+#include <xlist.h>
+#include <kmem.h>
+#include <thread.h>
+#include <rpc.h>
+#include <device.h>
+
+////////////////////////////////////////////////////////////////////////////////////
+// This array defines printable strings for devices functionnal types.
+////////////////////////////////////////////////////////////////////////////////////
+
+char * device_func_str[DEV_FUNC_NR] = 
+{
+  	"RAM",
+	"ROM",
+	"TXT",
+    "FBF",
+    "IOB",
+    "IOC",
+    "MMC",
+    "MWR",
+    "NIC",
+    "CMA",
+    "XCU",
+    "PIC"
+};
+
+////////////////////////////////////////
+xptr_t device_alloc( boot_info_t * info,
+                     bool_t        is_local )
+{
+    xptr_t     dev_xp;
+    device_t * dev_ptr;
+    uint32_t   index;
+    uint32_t   x;
+    uint32_t   y;
+    cxy_t      target_cxy;
+    kmem_req_t req;
+    error_t    error;
+
+    if( is_local )  // forced local allocation
+    {
+        req.type   = KMEM_DEVICE;
+        req.flags  = AF_ZERO;
+        dev_ptr    = (device_t *)kmem_alloc( &req );
+
+        if( dev_ptr == NULL ) return XPTR_NULL;
+        else                  return ( XPTR( local_cxy , dev_ptr ) );
+    }
+    else            // likely remote allocation
+    {
+        // select (pseudo-randomly) a target cluster
+        index      = ( hal_time_stamp() + hal_get_gid() ) % (info->x_size * info->y_size);
+        x          = index / info->y_size;    
+        y          = index % info->y_size;
+        target_cxy = (x<<info->y_width) + y;
+
+        if( target_cxy == local_cxy )   // local allocation
+        {
+            req.type   = KMEM_DEVICE;
+            req.flags  = AF_ZERO;
+            dev_ptr    = (device_t *)kmem_alloc( &req );
+
+            if( dev_ptr == NULL ) return XPTR_NULL;
+            else                  return ( XPTR( local_cxy , dev_ptr ) );
+        }
+        else                          // remote allocation
+        {
+            rpc_device_alloc_client( target_cxy , &dev_xp , &error );
+            if( error ) return XPTR_NULL;
+            else        return ( dev_xp );
+             
+        }
+    }   
+} // end device_alloc()
+
+
+/////////////////////////////////////
+void device_init( xptr_t      device,
+                  uint32_t    func,
+                  uint32_t    impl,
+                  uint32_t    channel,
+                  uint32_t    is_rx,
+                  xptr_t      base,
+                  uint32_t    size )
+{
+    // get device cluster and local pointer
+    cxy_t      cxy = GET_CXY( device );
+    device_t * ptr = (device_t *)GET_PTR( device );
+
+    // initialize waiting threads queue and associated lock
+    remote_spinlock_init( XPTR( cxy , &ptr->wait_lock ) );
+    xlist_root_init( XPTR( cxy , &ptr->wait_root ) );
+
+    // initialize basic attributes
+    hal_remote_sw ( XPTR( cxy , &ptr->func    ) , (uint32_t)func    );
+    hal_remote_sw ( XPTR( cxy , &ptr->impl    ) , (uint32_t)impl    );
+    hal_remote_sw ( XPTR( cxy , &ptr->channel ) , (uint32_t)channel );
+    hal_remote_sw ( XPTR( cxy , &ptr->is_rx   ) , (uint32_t)is_rx   );
+    hal_remote_swd( XPTR( cxy , &ptr->base    ) , (uint64_t)base    ); 
+    hal_remote_sw ( XPTR( cxy , &ptr->size    ) , (uint64_t)size    ); 
+
+}  // end device_init()
+
+////////////////////////////////////////////////
+void device_register_command( xptr_t     xp_dev,
+                              thread_t * thread )
+{
+    thread_t * thread_ptr = CURRENT_THREAD;
+
+    // get device descriptor cluster and local pointer
+    cxy_t      dev_cxy = GET_CXY( xp_dev );
+    device_t * dev_ptr = (device_t *)GET_PTR( xp_dev );
+
+    // build extended pointers on client thread xlist and device root
+    xptr_t  xp_list = XPTR( local_cxy , &thread_ptr->wait_list );
+    xptr_t  xp_root = XPTR( dev_cxy , &dev_ptr->wait_root );
+
+    // get lock protecting queue
+    remote_spinlock_lock( XPTR( dev_cxy , &dev_ptr->wait_lock ) );
+
+    // register client thread in waiting queue 
+    xlist_add_last( xp_root , xp_list );
+
+    // unblock server thread
+    thread_unblock( XPTR( dev_cxy , &dev_ptr->server ) , THREAD_BLOCKED_DEV_QUEUE );
+
+    // release lock
+    remote_spinlock_unlock( XPTR( dev_cxy , &dev_ptr->wait_lock ) );
+
+    // client thread goes to blocked state and deschedule
+    thread_block( thread_ptr , THREAD_BLOCKED_IO );
+    sched_yield();
+
+}  // end device register_command()
+
